{
  'targets': [
    {
      'target_name': 'niltree',
      'conditions': [
        ['OS=="win"', {
          'sources': [
            'main.cpp',
            'deps/exokit-bindings/bindings/src/*.cc',
            'deps/exokit-bindings/util/src/*.cc',
            'deps/exokit-bindings/canvas/src/*.cpp',
            'deps/exokit-bindings/nanosvg/src/*.cpp',
            'deps/exokit-bindings/canvascontext/src/*.cc',
            'deps/exokit-bindings/webglcontext/src/*.cc',
            'deps/exokit-bindings/platform/windows/src/*.cpp',
            'deps/exokit-bindings/webaudiocontext/src/*.cpp',
            'deps/exokit-bindings/videocontext/src/*.cpp',
            'deps/exokit-bindings/glfw/src/*.cc',
            'deps/openvr/src/*.cpp',
          ],
          'include_dirs': [
            '<(module_root_dir)/deps/native-graphics-deps/include',
            '<(module_root_dir)/deps/native-canvas-deps/include/core',
            '<(module_root_dir)/deps/native-canvas-deps/include/config',
            '<(module_root_dir)/deps/native-canvas-deps/include/gpu',
            '<(module_root_dir)/deps/native-canvas-deps/include/effects',
            '<(module_root_dir)/deps/native-audio-deps/include',
            '<(module_root_dir)/deps/native-video-deps/include',
            '<(module_root_dir)/deps/native-openvr-deps/headers',
            '<(module_root_dir)/deps/exokit-bindings',
            '<(module_root_dir)/deps/exokit-bindings/utf8',
            '<(module_root_dir)/deps/exokit-bindings/node',
            '<(module_root_dir)/deps/exokit-bindings/native_app_glue',
            '<(module_root_dir)/deps/exokit-bindings/util/include',
            '<(module_root_dir)/deps/exokit-bindings/bindings/include',
            '<(module_root_dir)/deps/exokit-bindings/canvas/include',
            '<(module_root_dir)/deps/exokit-bindings/nanosvg/include',
            '<(module_root_dir)/deps/exokit-bindings/canvascontext/include',
            '<(module_root_dir)/deps/exokit-bindings/webglcontext/include',
            '<(module_root_dir)/deps/exokit-bindings/webaudiocontext/include',
            '<(module_root_dir)/deps/exokit-bindings/videocontext/include',
            '<(module_root_dir)/deps/exokit-bindings/glfw/include',
            '<(module_root_dir)/deps/openvr/include',
          ],
          'library_dirs': [
            '<(module_root_dir)/deps/native-graphics-deps/lib/windows/glew',
            '<(module_root_dir)/deps/native-graphics-deps/lib/windows/glfw',
            '<(module_root_dir)/deps/native-canvas-deps/lib/windows',
            '<(module_root_dir)/deps/native-audio-deps/lib/windows',
            '<(module_root_dir)/deps/native-video-deps/lib/win',
            '<(module_root_dir)/deps/native-openvr-deps/lib/win64',
          ],
          'libraries': [
            'opengl32.lib',
            'glew32.lib',
            'glfw3dll.lib',
            'gdiplus.lib',
            'skia.lib',
            'LabSound.lib',
            'avformat.lib',
            'avcodec.lib',
            'avutil.lib',
            'swscale.lib',
            'swresample.lib',
            'openvr_api.lib',
          ],
          'copies': [
            {
              'destination': '<(module_root_dir)/build/Release/',
              'files': [
                '<(module_root_dir)/deps/native-graphics-deps/lib/windows/glew/glew32.dll',
                '<(module_root_dir)/deps/native-graphics-deps/lib/windows/glfw/glfw3.dll',
                '<(module_root_dir)/deps/native-video-deps/lib/win/avformat-58.dll',
                '<(module_root_dir)/deps/native-video-deps/lib/win/avcodec-58.dll',
                '<(module_root_dir)/deps/native-video-deps/lib/win/avutil-56.dll',
                '<(module_root_dir)/deps/native-video-deps/lib/win/swscale-5.dll',
                '<(module_root_dir)/deps/native-video-deps/lib/win/swresample-3.dll',
                '<(module_root_dir)/deps/native-openvr-deps/bin/win64/openvr_api.dll',
              ]
            }
          ],
          'defines': [
            'NOMINMAX',
          ],
        }],
        ['OS=="linux"', {
          'sources': [
            'main.cpp',
            '<!@(ls -1 deps/exokit-bindings/bindings/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/util/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/canvas/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/nanosvg/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/canvascontext/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/webglcontext/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/webaudiocontext/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/videocontext/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/glfw/src/*.cc)',
            '<!@(ls -1 deps/openvr/src/*.cpp)',
          ],
          'include_dirs': [
            '<(module_root_dir)/deps/native-graphics-deps/include',
            '<(module_root_dir)/deps/native-canvas-deps/include/core',
            '<(module_root_dir)/deps/native-canvas-deps/include/config',
            '<(module_root_dir)/deps/native-canvas-deps/include/gpu',
            '<(module_root_dir)/deps/native-canvas-deps/include/effects',
            '<(module_root_dir)/deps/native-audio-deps/include',
            '<(module_root_dir)/deps/native-video-deps/include',
            '<(module_root_dir)/deps/native-openvr-deps/headers',
            '<(module_root_dir)/deps/exokit-bindings',
            '<(module_root_dir)/deps/exokit-bindings/utf8',
            '<(module_root_dir)/deps/exokit-bindings/node',
            '<(module_root_dir)/deps/exokit-bindings/native_app_glue',
            '<(module_root_dir)/deps/exokit-bindings/util/include',
            '<(module_root_dir)/deps/exokit-bindings/bindings/include',
            '<(module_root_dir)/deps/exokit-bindings/canvas/include',
            '<(module_root_dir)/deps/exokit-bindings/nanosvg/include',
            '<(module_root_dir)/deps/exokit-bindings/canvascontext/include',
            '<(module_root_dir)/deps/exokit-bindings/webglcontext/include',
            '<(module_root_dir)/deps/exokit-bindings/webaudiocontext/include',
            '<(module_root_dir)/deps/exokit-bindings/videocontext/include',
            '<(module_root_dir)/deps/exokit-bindings/glfw/include',
            '<(module_root_dir)/deps/openvr/include',
          ],
          'library_dirs': [
            '<(module_root_dir)/deps/native-graphics-deps/lib/linux/glew',
            '<(module_root_dir)/deps/native-graphics-deps/lib/linux/glfw',
            '<(module_root_dir)/deps/native-canvas-deps/lib/linux',
            '<(module_root_dir)/deps/native-audio-deps/lib/linux',
            '<(module_root_dir)/deps/native-video-deps/lib/linux',
            '<(module_root_dir)/deps/native-video-deps/lib/linux/libavformat',
            '<(module_root_dir)/deps/native-video-deps/lib/linux/libavcodec',
            '<(module_root_dir)/deps/native-video-deps/lib/linux/libavutil',
            '<(module_root_dir)/deps/native-video-deps/lib/linux/libswscale',
            '<(module_root_dir)/deps/native-video-deps/lib/linux/libswresample',
            '<(module_root_dir)/deps/native-openvr-deps/lib/linux64',
          ],
          'libraries': [
            '-lGL',
            '-lGLU',
            '-lX11',
            '-lGLEW',
            '-lglfw3',
            '-lfontconfig',
            '-lfreetype',
            '-lpng16',
            '-lskia',
            '-lLabSound',
            '-lavformat',
            '-lavcodec',
            '-lavutil',
            '-lswscale',
            '-lswresample',
            '-lopenvr_api',
            '-luuid',
          ],
          'ldflags': [
            '-Wl,-Bsymbolic', # required for ffmpeg asm linkage
            '-Wl,--no-as-needed', # required to prevent elision of shared object linkage
            '-Wl,-rpath,./deps/native-graphics-deps/lib/linux/glew',
            '-Wl,-rpath,./deps/native-graphics-deps/lib/linux/glfw',
            '-Wl,-rpath,./deps/native-canvas-deps/lib/linux',
            '-Wl,-rpath,./deps/native-audio-deps/lib/linux',
            '-Wl,-rpath,./deps/native-video-deps/lib/linux/libavformat',
            '-Wl,-rpath,./deps/native-video-deps/lib/linux/libavcodec',
            '-Wl,-rpath,./deps/native-video-deps/lib/linux/libavutil',
            '-Wl,-rpath,./deps/native-video-deps/lib/linux/libswscale',
            '-Wl,-rpath,./deps/native-video-deps/lib/linux/libswresample',
            '-Wl,-rpath,./deps/native-openvr-deps/bin/linux64',
          ],
          'defines': [
            'NOMINMAX',
          ],
        }],
        ['OS=="mac"', {
          'sources': [
            'main.cpp',
            '<!@(ls -1 deps/exokit-bindings/bindings/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/util/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/canvas/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/nanosvg/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/canvascontext/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/webglcontext/src/*.cc)',
            '<!@(ls -1 deps/exokit-bindings/webaudiocontext/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/videocontext/src/*.cpp)',
            '<!@(ls -1 deps/exokit-bindings/glfw/src/*.cc)',
            '<!@(ls -1 deps/openvr/src/*.cpp)',
          ],
          'include_dirs': [
            '<(module_root_dir)/deps/native-graphics-deps/include',
            '<(module_root_dir)/deps/native-canvas-deps/include/core',
            '<(module_root_dir)/deps/native-canvas-deps/include/config',
            '<(module_root_dir)/deps/native-canvas-deps/include/gpu',
            '<(module_root_dir)/deps/native-canvas-deps/include/effects',
            '<(module_root_dir)/deps/native-audio-deps/include',
            '<(module_root_dir)/deps/native-video-deps/include',
            '<(module_root_dir)/deps/native-openvr-deps/headers',
            '<(module_root_dir)/deps/exokit-bindings',
            '<(module_root_dir)/deps/exokit-bindings/utf8',
            '<(module_root_dir)/deps/exokit-bindings/node',
            '<(module_root_dir)/deps/exokit-bindings/native_app_glue',
            '<(module_root_dir)/deps/exokit-bindings/util/include',
            '<(module_root_dir)/deps/exokit-bindings/bindings/include',
            '<(module_root_dir)/deps/exokit-bindings/canvas/include',
            '<(module_root_dir)/deps/exokit-bindings/nanosvg/include',
            '<(module_root_dir)/deps/exokit-bindings/canvascontext/include',
            '<(module_root_dir)/deps/exokit-bindings/webglcontext/include',
            '<(module_root_dir)/deps/exokit-bindings/webaudiocontext/include',
            '<(module_root_dir)/deps/exokit-bindings/videocontext/include',
            '<(module_root_dir)/deps/exokit-bindings/glfw/include',
            '<(module_root_dir)/deps/openvr/include',
          ],
          'library_dirs': [
            '<(module_root_dir)/deps/native-graphics-deps/lib/macos/glew',
            '<(module_root_dir)/deps/native-graphics-deps/lib/macos/glfw',
            '<(module_root_dir)/deps/native-canvas-deps/lib/macos',
            '<(module_root_dir)/deps/native-audio-deps/lib/macos',
            '<(module_root_dir)/deps/native-video-deps/lib/macos',
          ],
          'libraries': [
            '-framework OpenGL',
            '-framework Cocoa',
            '-lGLEW',
            '-lglfw3',
            '-lskia',
            '-framework CoreAudio',
            '-framework AudioUnit',
            '-framework AudioToolbox',
            '-llabsound',
            '-lavformat',
            '-lavcodec',
            '-lavutil',
            '-lswscale',
            '-lswresample',
            '-F <(module_root_dir)/deps/native-openvr-deps/bin/osx64',
            '-framework OpenVR',
          ],
          'link_settings': {
            'libraries': [
              '-Wl,-rpath,./deps/native-audio-deps/lib/macos',
              '-Wl,-rpath,./deps/native-video-deps/lib/macos',
              '-Wl,-rpath,./deps/native-openvr-deps/bin/osx64',
              '-framework OpenVR',
            ],
          },
        }],
      ],
    },
  ],
}
